/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Paging;

import com.rjconsultores.ventaboletos.entidad.ReservacionCtrl;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConfiguracionReservacion;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaConfiguracionReservacionController")
@Scope("prototype")
public class BusquedaConfiguracionReservacionController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<ReservacionCtrl> plwReservacionCtrl;
	private MyListbox reservacionCtrlList;
	private Paging pagingReservacionCtrl;
	private Datebox fecInicio;
	private Datebox fecFinal;

	public Paging getPagingReservacionCtrl() {
		return pagingReservacionCtrl;
	}

	public void setPagingReservacionCtrl(Paging pagingReservacionCtrl) {
		this.pagingReservacionCtrl = pagingReservacionCtrl;
	}

	public MyListbox getReservacionCtrlList() {
		return reservacionCtrlList;
	}

	public void setReservacionCtrlList(MyListbox reservacionCtrlList) {
		this.reservacionCtrlList = reservacionCtrlList;
	}

	public PagedListWrapper<ReservacionCtrl> getPlwReservacionCtrl() {
		return plwReservacionCtrl;
	}

	public void setPlwReservacionCtrl(PagedListWrapper<ReservacionCtrl> plwReservacionCtrl) {
		this.plwReservacionCtrl = plwReservacionCtrl;
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		pesquisarLista();
	}

	public void onClick$btnRefresh(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPeriodo(new ReservacionCtrl());
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		reservacionCtrlList.setItemRenderer(new RenderConfiguracionReservacion());
		reservacionCtrlList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				ReservacionCtrl rc = (ReservacionCtrl) reservacionCtrlList.getSelected();
				verPeriodo(rc);
			}
		});

		refreshLista();

		fecInicio.focus();
	}

	private void verPeriodo(ReservacionCtrl rc) {
		if (rc == null) {
			return;
		}

		Map args = new HashMap();
		args.put("reservacionCtrl", rc);
		args.put("reservacionCtrlList", reservacionCtrlList);

		openWindow("/gui/configuraciones_comerciales/editarConfiguracionReservacion.zul",
				Labels.getLabel("editarConfiguracionReservacionController.window.title"), args, MODAL);
	}

	private void refreshLista() throws InterruptedException {
		HibernateSearchObject<ReservacionCtrl> claseServicioBusqueda =
				new HibernateSearchObject<ReservacionCtrl>(ReservacionCtrl.class, pagingReservacionCtrl.getPageSize());

		claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);
		claseServicioBusqueda.addSortAsc("fecinicio");

		plwReservacionCtrl.init(claseServicioBusqueda, reservacionCtrlList, pagingReservacionCtrl);
	}

	private void pesquisarLista() throws InterruptedException {
		HibernateSearchObject<ReservacionCtrl> claseServicioBusqueda =
				new HibernateSearchObject<ReservacionCtrl>(ReservacionCtrl.class, pagingReservacionCtrl.getPageSize());

		if (fecInicio.getValue() != null && fecFinal.getValue() != null) {

			Date inicio = DateUtil.inicioFecha(fecInicio.getValue());
			Date fin = DateUtil.fimFecha(fecFinal.getValue());

			claseServicioBusqueda.addFilterGreaterOrEqual("fecinicio", inicio);
			claseServicioBusqueda.addFilterLessOrEqual("fecfinal", fin);

		} else {
			Messagebox.show(Labels.getLabel("busquedaConfiguracionReservacionController.periodo.label"),
					Labels.getLabel("busquedaConfiguracionReservacionController.window.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
		}

		claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);
		claseServicioBusqueda.addSortAsc("fecinicio");

		plwReservacionCtrl.init(claseServicioBusqueda, reservacionCtrlList, pagingReservacionCtrl);

		if (reservacionCtrlList.getData().length == 0) {
			Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
					Labels.getLabel("busquedaConfiguracionReservacionController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
		}
	}
}
